Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 454838 - LTC:4.8:201714:Update the ehea driver to sync with mainline kernel [NEEDINFO]
Summary: LTC:4.8:201714:Update the ehea driver to sync with mainline kernel
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel
Version: 4.8
Hardware: ppc64
OS: All
high
high
Target Milestone: beta
: 4.8
Assignee: Ameet Paranjape
QA Contact: Martin Jenner
URL:
Whiteboard:
Depends On:
Blocks: 458123 RHEL4u8_relnotes 461297
TreeView+ depends on / blocked
 
Reported: 2008-07-10 04:31 UTC by IBM Bug Proxy
Modified: 2018-10-17 18:12 UTC (History)
7 users (show)

Fixed In Version:
Doc Type: Enhancement
Doc Text:
The eHEA ethernet device driver for IBM eServer System P has been updated to version 0078-08.
Clone Of:
Environment:
Last Closed: 2009-05-18 19:14:55 UTC
Target Upstream Version:
rlerch: needinfo? (aparanja)


Attachments (Terms of Use)
eHEA device driver update from version 0078-03 to 0078-07 (deleted)
2008-08-11 11:01 UTC, IBM Bug Proxy
no flags Details
eHEA device driver update from version 0078-04 to 0078-07 (deleted)
2008-11-21 13:41 UTC, IBM Bug Proxy
no flags Details
eHEA device driver update from version 0078-04 to 0078-08 (deleted)
2008-12-04 15:52 UTC, IBM Bug Proxy
no flags Details
eHEA device driver update from version 0078-04 to 0078-08 (deleted)
2008-12-08 12:03 UTC, IBM Bug Proxy
no flags Details


Links
System ID Priority Status Summary Last Updated
IBM Linux Technology Center 46253 None None None Never
Red Hat Product Errata RHSA-2009:1024 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 4.8 kernel security and bug fix update 2009-05-18 14:57:26 UTC

Description IBM Bug Proxy 2008-07-10 04:31:12 UTC
=Comment: #0=================================================
Emily J. Ratliff <emilyr@us.ibm.com> - 2008-07-09 17:31 EDT
1. Feature Id:	[201714]
Feature Name:	Update the ehea driver to sync with mainline kernel
Sponsor:	PPC
Category:	Device Drivers and IO
Request Type:	Driver - Update Version

2. Short Description
Multiple ehea driver fixes have been identified in the late cycles of RHEL4.7.  Since all of the
changes have been accepted into mainline kernel, the purpose of this feature is to hopefully make
codedrop for 4.8 rather than piece meal the patches.

3. Business Case
Provide bug fixes for known eHEA problems on p6 servers/Blades.


4. Sponsor Priority	1
IBM Confidential:	no
Code Contribution:	IBM code
Upstream Acceptance:	Accepted
Component Version Target:	kernel 2.6.26
Performance Assistance:	

5. PM Contact:	Stephanie Glass, sglass@us.ibm.com, 512-838-9284

6. Technical contact(s):
Daisy Chang, daisyc@us.ibm.com
Jan-Bernd Themann, themann@de.ibm.com

7. LTC Manager: Wendel Voigt, wvoigt@us.ibm.com

Comment 1 John Jarvis 2008-07-15 15:29:41 UTC
IBM is signed up to test and provide feedback

Comment 2 IBM Bug Proxy 2008-08-11 11:01:05 UTC
Created attachment 313949 [details]
eHEA device driver update from version 0078-03 to 0078-07

This patch updates the eHEA driver with fixes accepted in the mainline kernel.
The driver includes

- Bug #41989 - RIT 162498: ehea_treat_poll_error, TCP/UDP checksum err
- Bug #44676 - RIT 183048: Errors on patched RH4U7 bonding device removing team

- Bug #45441 - RIT 184964: eHEA bonding setup generates firmware errors

plus further improvements and code cleanups. 

This driver has executed the following tests succesfully:
- ipv4: ping, flood ping, broadcast ping
- ipv6: ping, flood ping, TCP traffic
- flood ping with big pakets
- ftp tests with large files using 4 connections with TSO on/off
- ftp long run using 4 connections with TSO on/off
- netpipe
- netperf
- netperf via IPv6
- netperf using LRO
- netperf/udp
- vlan ping
- multicast basic
- kdump/kexec
- DLPAR port add/remove

Mainline kernel postings:

* ehea: Reworked rcv queue handling to log only fatal errors
    http://lkml.org/lkml/2007/11/21/171
    applied: http://lkml.org/lkml/2007/11/23/181

* Remove unnecessary memset after kzalloc
    http://lkml.org/lkml/2008/5/12/318
    applied: http://lkml.org/lkml/2008/5/22/129

* Fix use after free on reboot (Patch not sent by ehea dev team)
    http://www.spinics.net/lists/netdev/msg63167.html
    applied: http://www.spinics.net/lists/netdev/msg63933.html

* Access iph->tot_len with correct endianness (Patch not sent by ehea dev team)

    http://www.spinics.net/lists/netdev/msg67519.html
    applied: http://www.spinics.net/lists/netdev/msg67870.html

* Set mac address fix
    http://lkml.org/lkml/2008/6/9/180
    applied: http://lkml.org/lkml/2008/6/10/424

Comment 3 RHEL Product and Program Management 2008-09-03 13:00:14 UTC
Updating PM score.

Comment 4 John Jarvis 2008-09-26 15:51:05 UTC
This enhancement request was evaluated by the full Red Hat Enterprise Linux team
for inclusion in a Red Hat Enterprise Linux minor release.   As a result of this
evaluation, Red Hat has tentatively approved inclusion of this feature in the
next Red Hat Enterprise Linux Update minor release.   While it is a goal to
include this enhancement in the next minor release of Red Hat Enterprise Linux,
the enhancement is not yet committed for inclusion in the next minor release
pending the next phase of actual code integration and successful Red Hat and
partner testing.

Comment 5 Michal Schmidt 2008-10-14 13:44:58 UTC
*** Bug 450688 has been marked as a duplicate of this bug. ***

Comment 6 IBM Bug Proxy 2008-11-21 13:41:28 UTC
Created attachment 324303 [details]
eHEA device driver update from version 0078-04 to 0078-07

This patch updates the eHEA driver with fixes accepted in the mainline kernel.
The driver includes

- Bug #41989 - RIT 162498: ehea_treat_poll_error, TCP/UDP checksum err
- Bug #44676 - RIT 183048: Errors on patched RH4U7 bonding device removing team

- Bug #45441 - RIT 184964: eHEA bonding setup generates firmware errors

plus further improvements and code cleanups. 

This driver has executed the following tests succesfully:
- ipv4: ping, flood ping, broadcast ping
- ipv6: ping, flood ping, TCP traffic
- flood ping with big pakets
- ftp tests with large files using 4 connections with TSO on/off
- ftp long run using 4 connections with TSO on/off
- netpipe
- netperf
- netperf via IPv6
- netperf using LRO
- netperf/udp
- vlan ping
- multicast basic
- kdump/kexec
- DLPAR port add/remove

Mainline kernel postings:

* ehea: Reworked rcv queue handling to log only fatal errors
    http://lkml.org/lkml/2007/11/21/171
    applied: http://lkml.org/lkml/2007/11/23/181

* Remove unnecessary memset after kzalloc
    http://lkml.org/lkml/2008/5/12/318
    applied: http://lkml.org/lkml/2008/5/22/129

* Fix use after free on reboot (Patch not sent by ehea dev team)
    http://www.spinics.net/lists/netdev/msg63167.html
    applied: http://www.spinics.net/lists/netdev/msg63933.html

* Access iph->tot_len with correct endianness (Patch not sent by ehea dev team)

    http://www.spinics.net/lists/netdev/msg67519.html
    applied: http://www.spinics.net/lists/netdev/msg67870.html

* Set mac address fix
    http://lkml.org/lkml/2008/6/9/180
    applied: http://lkml.org/lkml/2008/6/10/424

Comment 8 IBM Bug Proxy 2008-12-04 15:52:00 UTC
Created attachment 325696 [details]
eHEA device driver update from version 0078-04 to 0078-08



This patch updates the eHEA driver with fixes accepted in the mainline kernel.
The driver includes

- Bug #41989 - RIT 162498: ehea_treat_poll_error, TCP/UDP checksum err
- Bug #44676 - RIT 183048: Errors on patched RH4U7 bonding device removing team
- Bug #45441 - RIT 184964: eHEA bonding setup generates firmware errors

plus further improvements and code cleanups. 

This driver has executed the following tests succesfully:
- ipv4: ping, flood ping, broadcast ping
- ipv6: ping, flood ping, TCP traffic
- flood ping with big pakets
- ftp tests with large files using 4 connections with TSO on/off
- ftp long run using 4 connections with TSO on/off
- netpipe
- netperf
- netperf via IPv6
- netperf using LRO
- netperf/udp
- vlan ping
- multicast basic
- kdump/kexec
- DLPAR port add/remove

Mainline kernel postings:

* Remove unnecessary memset after kzalloc
    http://lkml.org/lkml/2008/5/12/318
    applied: http://lkml.org/lkml/2008/5/22/129

* Fix use after free on reboot (Patch not sent by ehea dev team)
    http://www.spinics.net/lists/netdev/msg63167.html
    applied: http://www.spinics.net/lists/netdev/msg63933.html

* Set mac address fix
    http://lkml.org/lkml/2008/6/9/180
    applied: http://lkml.org/lkml/2008/6/10/424

The updated patch now actually contains the fix:
* Access iph->tot_len with correct endianness (Patch not sent by ehea dev team)
    http://www.spinics.net/lists/netdev/msg67519.html
    applied: http://www.spinics.net/lists/netdev/msg67870.html
Thanks for pointing this out. We missed this one.

Please be aware that the old patch attached first in this bugzilla contained the fix

* ehea: Reworked rcv queue handling to log only fatal errors
    http://lkml.org/lkml/2007/11/21/171
    applied: http://lkml.org/lkml/2007/11/23/181

However, this patch was already fixed with driver version 0078-04. This patch is based on driver 0078-04 which already contains this fix and does not appear in the latest patch.

The double underscore denotes bit names used with set_bit()/clear_bit(). This is common practise in mainline Linux kernel and the network stack. As example for this look at include/linux/netdevice.h enum netdev_state_t.

Comment 9 IBM Bug Proxy 2008-12-08 12:03:29 UTC
Created attachment 326116 [details]
eHEA device driver update from version 0078-04 to 0078-08



This patch is the same as the patch posted on comment  #21 (2008-12-03 10:51:51 EST) except that the patch 
* Access iph->tot_len with correct endianness
    http://www.spinics.net/lists/netdev/msg67519.html
    applied: http://www.spinics.net/lists/netdev/msg67870.html
is correctly merged into the code. In the last version, the complete line was exchanged which is not correct for RedHat 4 kernel. The endianness problem is solved, but the length calculation remains the same.

Comment 10 IBM Bug Proxy 2008-12-10 10:31:16 UTC
This code fragment which is not mentioned in the description is a patch only necessary for RHEL 4. Please look at bug #44676 (RIT 183048) comment #26, comment #37 and comment #50.

Comment 11 Vivek Goyal 2008-12-17 16:07:58 UTC
Committed in 78.22.EL . RPMS are available at http://people.redhat.com/vgoyal/rhel4/

Comment 13 Ameet Paranjape 2009-01-29 15:57:26 UTC
Release note added. If any revisions are required, please set the 
"requires_release_notes" flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

New Contents:
* Cause:   What actions or circumstances induced the feature request.
Update the ehea driver to sync with mainline kernel.  Since all of the changes have been accepted into mainline kernel, the purpose of this feature is to make codedrop for RHEL4.8 rather than piece meal the patches.

* Consequence:  What action was inhibited by the feature's absence.
Known eHEA problems on POWER6 servers/Blades.

* Fix:   What was done to implement the feature.
Backport mainline fixes to RHEL4.8 kernel.

* Result:  now happens when the actions or circumstances above occur. (NB: this
is not the same as 'the feature request was fulfilled')
The eHEA driver problems on POWER6 servers should not occur.

Comment 15 Chris Ward 2009-02-20 12:09:54 UTC
~~ Attention Partners!  ~~
RHEL 4.8 Partner Alpha has been released on partners.redhat.com. There should be a fix present in the Beta, which addresses this URGENT priority bug. If you haven't had a chance yet to test this bug, please do so at your earliest convenience, to ensure that only the highest possible quality bits are shipped in the upcoming public Beta drop.

If you encounter any issues, please set the bug back to the ASSIGNED state and describe the issues you encountered. Further questions can be directed to your Red Hat Partner Manager.

Thanks, more information about Beta testing to come.
 - Red Hat QE Partner Management

Comment 16 Chris Ward 2009-02-20 13:31:39 UTC
~~ Attention Partners!  ~~
RHEL 4.8 Partner Alpha has been released on partners.redhat.com. There should
be a fix present in the Beta, which addresses this bug. If you have already completed testing your other URGENT priority bugs, and you still haven't had a chance yet to test this bug, please do so at your earliest convenience, to ensure that only the highest possible quality bits are shipped in the upcoming public Beta drop.

If you encounter any issues, please set the bug back to the ASSIGNED state and
describe the issues you encountered. Further questions can be directed to your
Red Hat Partner Manager.

Thanks, more information about Beta testing to come.
 - Red Hat QE Partner Management

Comment 17 Chris Ward 2009-03-13 14:03:14 UTC
~~ Attention Partners!  ~~
RHEL 4.8Beta has been released on partners.redhat.com. There should
be a fix present, which addresses this bug. Please test and report back results on this OtherQA Partner bug at your earliest convenience.

If you encounter any issues, please set the bug back to the ASSIGNED state and
describe any issues you encountered. If you have found a NEW bug, clone this bug and describe the issues you've encountered. Further questions can be directed to your Red Hat Partner Manager.

If you have VERIFIED the bug fix. Please select your PartnerID from the Verified field above. Please leave a comment with your test results details. Include which arches tested, package version and any applicable logs.

 - Red Hat QE Partner Management

Comment 19 IBM Bug Proxy 2009-03-24 14:30:34 UTC
------- Comment From HERING2@de.ibm.com 2009-03-24 10:25 EDT-------
The ehea driver contained in the RHEL 4.8 beta is at the expected driver level.

The driver has executed the following tests succesfully:
- ipv4: ping, flood ping, broadcast ping
- ipv6: ping, flood ping, TCP traffic
- flood ping with big pakets
- ftp tests with large files using 4 connections with TSO on/off
- ftp long run using 4 connections with TSO on/off
- netpipe
- netperf
- netperf via IPv6
- netperf using LRO
- netperf/udp
- vlan ping
- multicast basic

I'm closing the bug as the driver is in the kernel.

Comment 21 Ryan Lerch 2009-03-26 23:22:18 UTC
aparanja,

would it be possible to get some details (in the release notes field) of the specific fixes this update provides?

cheers,
ryanlerch

Comment 22 Ryan Lerch 2009-03-26 23:22:18 UTC
Release note updated. If any revisions are required, please set the 
"requires_release_notes"  flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

Diffed Contents:
@@ -1,12 +1,2 @@
-* Cause:   What actions or circumstances induced the feature request.
+The eHEA ethernet device driver for IBM eServer System P has been updated to version 0078-08. This update resolves the following issues:
-Update the ehea driver to sync with mainline kernel.  Since all of the changes have been accepted into mainline kernel, the purpose of this feature is to make codedrop for RHEL4.8 rather than piece meal the patches.
+*-
-* Consequence:  What action was inhibited by the feature's absence.
-Known eHEA problems on POWER6 servers/Blades.
-
-* Fix:   What was done to implement the feature.
-Backport mainline fixes to RHEL4.8 kernel.
-
-* Result:  now happens when the actions or circumstances above occur. (NB: this
-is not the same as 'the feature request was fulfilled')
-The eHEA driver problems on POWER6 servers should not occur.

Comment 23 IBM Bug Proxy 2009-03-27 15:30:41 UTC
------- Comment From HERING2@de.ibm.com 2009-03-27 11:26 EDT-------
This patch contains fixes for these bugs:
Bug #41989: JS12/ehea: ehea_treat_poll_error, TCP/UDP checksum err (DUP: 42940)
Bug #44676: Errors on patched RH4U7 bonding device removing team
Bug #45441: eHEA bonding setup generates firmware errors
Bug #45341: Issue removing bonding driver
It also contains these mainline kernel fixes:
Access iph->tot_len with correct endianness
http://www.spinics.net/lists/netdev/msg67519.html
applied http://www.spinics.net/lists/netdev/msg67870.html

Comment 24 Ryan Lerch 2009-04-07 23:46:54 UTC
Release note updated. If any revisions are required, please set the 
"requires_release_notes"  flag to "?" and edit the "Release Notes" field accordingly.
All revisions will be proofread by the Engineering Content Services team.

Diffed Contents:
@@ -1,2 +1 @@
-The eHEA ethernet device driver for IBM eServer System P has been updated to version 0078-08. This update resolves the following issues:
+The eHEA ethernet device driver for IBM eServer System P has been updated to version 0078-08.-*

Comment 26 IBM Bug Proxy 2009-04-29 15:02:45 UTC
------- Comment From HERING2@de.ibm.com 2009-04-29 10:53 EDT-------
The ehea driver contained in the RHEL 4.8 KOTD version 2.6.9-89.EL is at the expected driver level EHEA_0078-08.

The driver has executed the following tests succesfully:
- ipv4: ping, flood ping, broadcast ping
- ipv6: ping, flood ping, TCP traffic
- flood ping with big pakets
- ftp tests with large files using 4 connections with TSO on/off
- ftp long run using 4 connections with TSO on/off
- netpipe
- netperf
- netperf via IPv6
- netperf using LRO
- netperf/udp
- vlan ping
- multicast basic

Regards

Hannes

Comment 28 errata-xmlrpc 2009-05-18 19:14:55 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1024.html


Note You need to log in before you can comment on or make changes to this bug.